SystemOrganization addCategory: #'A4BP-SimEngine-core'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-Tests'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-execution'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-model'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-model-a4bp'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-parser'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-parser-builder-visitors'!
SystemOrganization addCategory: 'A4BP-SimEngine-core-visitors'!

A4BPObject subclass: #BPSimObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

BPSimObject subclass: #BPSimCalendar
	instanceVariableNames: 'id value name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimCalendar methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimCalendar: self! !

!BPSimCalendar methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:28'!
id
^id! !

!BPSimCalendar methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:28'!
name
	^ name! !

!BPSimCalendar methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:29'!
name: aString
	name := aString! !

BPSimObject subclass: #BPSimControlParameters
	instanceVariableNames: 'condition triggerCount interTriggerTimer probability'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimControlParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimControlParameters: self! !

BPSimObject subclass: #BPSimCostParameters
	instanceVariableNames: 'fixedCost unitCost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimCostParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimCostParameters: self! !

BPSimObject subclass: #BPSimData
	instanceVariableNames: 'scenarios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimData class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:54'!
fillElementsIn: aModel from: document
	| visitor |
	visitor := BPSimParserDataVisitor new.
	visitor element: aModel.
	self fillElementsIn: aModel from: document visitor: visitor.
! !

!BPSimData methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimData: self! !

!BPSimData methodsFor: 'adding' stamp: 'SergeStinckwich 3/9/2015 15:34'!
addScenario: aScenario
	scenarios add: aScenario! !

!BPSimData methodsFor: 'initialization' stamp: 'SergeStinckwich 3/9/2015 15:34'!
initialize
	scenarios := OrderedCollection new! !

!BPSimData methodsFor: 'accessing' stamp: 'SergeStinckwich 3/6/2015 15:24'!
scenarios
	^ scenarios! !

BPSimObject subclass: #BPSimDuration
	instanceVariableNames: 'constantParameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model-a4bp'!

!BPSimDuration class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:38'!
fillElementsIn: aModel from: document
	| visitor |
	visitor := BPSimParserDurationVisitor new.
	visitor element: aModel.
	self fillElementsIn: aModel from: document visitor: visitor.
! !

!BPSimDuration methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:35'!
accept: aVisitor
	^ aVisitor visitBPDuration: self! !

!BPSimDuration methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:41'!
constantParameter
	^ constantParameter! !

!BPSimDuration methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:41'!
constantParameter: aConstantParameter
	^ constantParameter := aConstantParameter ! !

BPSimObject subclass: #BPSimElementParameters
	instanceVariableNames: 'costParameters id resourceParameters controlParameters vendorExtension propertyParameters priorityParameters elementRef timeParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimElementParameters class methodsFor: 'parser' stamp: 'SergeStinckwich 3/9/2015 17:47'!
fromXMLDescription: xmlDescription
	| answer |
	answer := self new.
	answer id: (xmlDescription attributeAt: 'id').
	answer elementRef:(xmlDescription attributeAt: 'elementRef').
	(xmlDescription allElementsNamed: 'bpsim:PropertyParameters')
		do: [ :elements | answer propertyParameters: (BPSimPropertyParameters fromXMLDescription: elements) ].
	^ answer! !

!BPSimElementParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimElementParameters: self! !

!BPSimElementParameters methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:37'!
elementRef
	^ elementRef! !

!BPSimElementParameters methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:37'!
elementRef: aBPMNElementReference
	elementRef := aBPMNElementReference! !

!BPSimElementParameters methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:37'!
id
	^ id! !

!BPSimElementParameters methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:37'!
timeParameters
	^ timeParameters! !

!BPSimObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:59'!
fillElementsIn: aBPObject from: document visitor: visitor
	self
		fillElementsIn: aBPObject
		from: document
		visitor: visitor
		tagRef: BPSimParserTagsXMLRef! !

!BPSimObject methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:43'!
accept: aVisitor
	^ aVisitor visitBPSimObject: self! !

BPSimObject subclass: #BPSimObjectFactory
	instanceVariableNames: '_ErlangDistribution_QNAME _DateTimeParameter_QNAME _LogNormalDistribution_QNAME _BooleanParameter_QNAME _BinomialDistribution_QNAME _FloatingParameter_QNAME _BetaDistribution_QNAME _EnumParameter_QNAME _DurationParameter_QNAME _TriangularDistribution_QNAME _NormalDistribution_QNAME _GammaDistribution_QNAME _PoissonDistribution_QNAME _WeibullDistribution_QNAME _NumericParameter_QNAME _ExpressionParameter_QNAME _StringParameter_QNAME _NegativeExponentialDistribution_QNAME _TruncatedNormalDistribution_QNAME _UserDistribution_QNAME _ParameterValue_QNAME _UniformDistribution_QNAME'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimObjectFactory class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 17:49'!
fromXMLDescription: xmlDescription! !

!BPSimObjectFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimObjectFactory: self! !

BPSimObject subclass: #BPSimParameter
	instanceVariableNames: 'kpi sla parameterValue resultRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimParameter class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 17:49'!
fromXMLDescription: xmlDescription! !

!BPSimParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimParameter: self! !

BPSimParameter subclass: #BPSimProperty
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimProperty class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 17:49'!
fromXMLDescription: xmlDescription! !

!BPSimProperty methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimProperty: self! !

BPSimObject subclass: #BPSimParameterValue
	instanceVariableNames: 'instance validFor result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

BPSimParameterValue subclass: #BPSimConstantParameter
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

BPSimConstantParameter subclass: #BPSimBooleanParameter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimBooleanParameter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:48'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimBooleanParameter class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 22:11'!
fromXMLDescription: xmlDescription
	| answer |
	answer := self new.
	answer value: (xmlDescription attributeAt:'value') = 'true'.
	^ answer! !

!BPSimBooleanParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimBooleanParameter: self! !

!BPSimBooleanParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:30'!
value
	^ value! !

!BPSimBooleanParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:31'!
value: aBoolean
	value := aBoolean! !

!BPSimConstantParameter class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:49'!
fillElementsIn: aModel from: document
	aModel value: (self readArt: document at: 'value').
! !

!BPSimConstantParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimConstantParameter: self! !

!BPSimConstantParameter methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:45'!
value
	^ value! !

!BPSimConstantParameter methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:45'!
value: aValue
	^ value := aValue! !

BPSimConstantParameter subclass: #BPSimDateTimeParameter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimDateTimeParameter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:48'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimDateTimeParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimDateTimeParameter: self! !

BPSimConstantParameter subclass: #BPSimDurationParameter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimDurationParameter class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:47'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimDurationParameter class methodsFor: 'parser' stamp: 'SergeStinckwich 3/9/2015 22:06'!
fromXMLDescription: xmlDescription
	| answer |
	answer := self new.
	answer value: (xmlDescription attributeAt:'value').
	^ answer! !

!BPSimDurationParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimDurationParameter: self! !

!BPSimDurationParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:57'!
value
	^ value! !

!BPSimDurationParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 22:12'!
value: aString
	value := aString! !

BPSimConstantParameter subclass: #BPSimFloatingParameter
	instanceVariableNames: 'timeUnit currencyUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimFloatingParameter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:48'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimFloatingParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimFloatingParameter: self! !

BPSimConstantParameter subclass: #BPSimNumericParameter
	instanceVariableNames: 'timeUnit currencyUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimNumericParameter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:48'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimNumericParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimNumericParameter: self! !

BPSimConstantParameter subclass: #BPSimStringParameter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimStringParameter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:48'!
fillElementsIn: aModel from: document
	super fillElementsIn: aModel from: document
! !

!BPSimStringParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimStringParameter: self! !

!BPSimStringParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 22:03'!
value
	^ value! !

BPSimParameterValue subclass: #BPSimDistributionParameter
	instanceVariableNames: 'timeUnit currencyUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

BPSimDistributionParameter subclass: #BPSimBetaDistribution
	instanceVariableNames: 'scale shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimBetaDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimBetaDistribution: self! !

BPSimDistributionParameter subclass: #BPSimBinomialDistribution
	instanceVariableNames: 'trials probability'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimBinomialDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimBinomialDistribution: self! !

!BPSimDistributionParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimDistributionParameter: self! !

!BPSimDistributionParameter methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:34'!
currencyUnit
	^ currencyUnit! !

BPSimDistributionParameter subclass: #BPSimErlangDistribution
	instanceVariableNames: 'k mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimErlangDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimErlangDistribution: self! !

BPSimDistributionParameter subclass: #BPSimGammaDistribution
	instanceVariableNames: 'shape scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimGammaDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimGammaDistribution: self! !

BPSimDistributionParameter subclass: #BPSimLogNormalDistribution
	instanceVariableNames: 'standardDeviation mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimLogNormalDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimLogNormalDistribution: self! !

BPSimDistributionParameter subclass: #BPSimNegativeExponentialDistribution
	instanceVariableNames: 'mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimNegativeExponentialDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimNegativeExponentialDistribution: self! !

BPSimDistributionParameter subclass: #BPSimNormalDistribution
	instanceVariableNames: 'standardDeviation mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimNormalDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimNormalDistribution: self! !

BPSimDistributionParameter subclass: #BPSimPoissonDistribution
	instanceVariableNames: 'mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimPoissonDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimPoissonDistribution: self! !

BPSimDistributionParameter subclass: #BPSimTriangularDistribution
	instanceVariableNames: 'mode max min'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimTriangularDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimTriangularDistribution: self! !

!BPSimTriangularDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
max
^max! !

!BPSimTriangularDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
min
^min! !

!BPSimTriangularDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
mode
	^ mode! !

BPSimDistributionParameter subclass: #BPSimTruncatedNormalDistribution
	instanceVariableNames: 'max min standardDeviation mean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimTruncatedNormalDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimTruncatedNormalDistribution: self! !

!BPSimTruncatedNormalDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
max
	^ max! !

!BPSimTruncatedNormalDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
mean
	^ mean! !

!BPSimTruncatedNormalDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
min
	^ min! !

!BPSimTruncatedNormalDistribution methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 15:36'!
standardDeviation
	^ standardDeviation! !

BPSimDistributionParameter subclass: #BPSimUniformDistribution
	instanceVariableNames: 'max min'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimUniformDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimUniformDistribution: self! !

BPSimDistributionParameter subclass: #BPSimUserDistribution
	instanceVariableNames: 'discrete userDistributionDataPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimUserDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimUserDistribution: self! !

BPSimDistributionParameter subclass: #BPSimWeibullDistribution
	instanceVariableNames: 'shape scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimWeibullDistribution methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimWeibullDistribution: self! !

BPSimParameterValue subclass: #BPSimEnumParameter
	instanceVariableNames: 'parameterValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimEnumParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimEnumParameter: self! !

BPSimParameterValue subclass: #BPSimExpressionParameter
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimExpressionParameter methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimExpressionParameter: self! !

!BPSimParameterValue methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimParameterValue: self! !

BPSimObject subclass: #BPSimPriorityParameters
	instanceVariableNames: 'priority interruptible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimPriorityParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimPriorityParameters: self! !

BPSimObject subclass: #BPSimPropertyParameters
	instanceVariableNames: 'property'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimPropertyParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimPropertyParameters: self! !

BPSimObject subclass: #BPSimResourceParameters
	instanceVariableNames: 'availability role selection quantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimResourceParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimResourceParameters: self! !

BPSimObject subclass: #BPSimScenario
	instanceVariableNames: 'version name vendorExtension author inherits calendar elementParameters result created id vendor modified description scenarioParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimScenario class methodsFor: 'meta' stamp: 'SergeStinckwich 3/9/2015 15:51'!
annotation
	<abstract>
	<MSEClass: #Scenario super: #MooseEntity>
	<package: #BPSim>! !

!BPSimScenario class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:50'!
fillElementsIn: aModel from: document
	| visitor |
	visitor := BPSimParserScenarioVisitor new.
	visitor element: aModel.
	self fillElementsIn: aModel from: document visitor: visitor.
! !

!BPSimScenario class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:51'!
fromXMLDescription: document
	| answer |
	answer := self new.
	self fillBData: document in: answer.
	
	answer author: (self readArt: document at: 'author').
	answer id: (self readArt: document at: 'id').
	answer name: (self readArt: document at: 'name').

	self fillElementsIn: answer from: document.

	^ answer! !

!BPSimScenario class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/11/2015 08:22'!
fromXMLDescription: document in: parent
	| answer |
	answer := self new.
	self fillBData: document in: answer.
	
	answer author: (self readArt: document at: 'author').
	answer id: (self readArt: document at: 'id').
	answer description: (self readArt: document at: 'description').
	answer vendor: (self readArt: document at: 'vendor').
	answer version: (self readArt: document at: 'version').

	self fillElementsIn: answer from: document.

	^ answer! !

!BPSimScenario methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimScenario: self! !

!BPSimScenario methodsFor: 'adding' stamp: 'SergeStinckwich 3/9/2015 15:37'!
addElementParameters: anElementParameters
	elementParameters add: anElementParameters! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
author
	^ author! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
author: aString
	author := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
created: aString
	created := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
description
	<MSEProperty: #description type: #String>
	<MSEComment: 'A description of this scenario'>
	^ description! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:22'!
description: aString
	description := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
elementParameters
	^ elementParameters! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
id
	^ id! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
id: anID
	id := anID! !

!BPSimScenario methodsFor: 'initialization' stamp: 'SergeStinckwich 3/9/2015 15:38'!
initialize
	elementParameters := Set new! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
modified: aString
	modified := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
name
	<MSEProperty: #name type: #String>
	<MSEComment: 'A name for this scenario'>
	^ name! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:38'!
name: aString
	name := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:39'!
scenarioParameters
	^ scenarioParameters! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:54'!
scenarioParameters: aScenarioParameters
	scenarioParameters := aScenarioParameters! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:20'!
vendor
	^ vendor! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:20'!
vendor: aString
	vendor := aString! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:20'!
version
	^ version! !

!BPSimScenario methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 21:20'!
version: aString
	version := aString! !

BPSimObject subclass: #BPSimScenarioParameters
	instanceVariableNames: 'duration baseTimeUnit baseCurrencyUnit replication start seed propertyParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimScenarioParameters class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:31'!
fillElementsIn: aModel from: document
	| visitor |
	visitor := BPSimParserScenarioParametersVisitor new.
	visitor element: aModel.
	self fillElementsIn: aModel from: document visitor: visitor.
! !

!BPSimScenarioParameters class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:31'!
fromXMLDescription: document in: parent
	| answer |
	answer := self new.
	self fillBData: document in: answer.
	answer replication: (self readInt: document at: 'replication').
	answer baseTimeUnit: (self readArt: document at: 'baseTimeUnit').
	answer seed: (self readInt: document at: 'seed').

	self fillElementsIn: answer from: document.

	^ answer! !

!BPSimScenarioParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimScenarioParameters: self! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:40'!
baseCurrencyUnit
	^ baseCurrencyUnit! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:40'!
baseCurrencyUnit: aString
	baseCurrencyUnit := aString! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:32'!
baseTimeUnit
	^ baseTimeUnit! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:32'!
baseTimeUnit: aString
	baseTimeUnit := aString! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:39'!
duration
	^ duration! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:39'!
duration: aDurationParameter
	duration := aDurationParameter! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:39'!
replication
	^ replication! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:40'!
replication: anInteger
	replication := anInteger! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:40'!
seed
	^ seed! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 17:40'!
seed: anInteger
	seed := anInteger! !

!BPSimScenarioParameters methodsFor: 'accessing' stamp: 'SergeStinckwich 3/9/2015 15:40'!
start
	^ start! !

BPSimObject subclass: #BPSimTimeParameters
	instanceVariableNames: 'validationTime queueTime transferTime waitTime reworkTime processingTime setUpTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimTimeParameters class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 17:50'!
fromXMLDescription: xmlDescription! !

!BPSimTimeParameters methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimTimeParameters: self! !

BPSimObject subclass: #BPSimUserDistributionDataPoint
	instanceVariableNames: 'probability parameterValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimUserDistributionDataPoint methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimUserDistributionDataPoint: self! !

BPSimObject subclass: #BPSimVendorExtension
	instanceVariableNames: 'any name otherAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-model'!

!BPSimVendorExtension class methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 3/9/2015 17:50'!
fromXMLDescription: xmlDescription! !

!BPSimVendorExtension methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:42'!
accept: aVisitor
	^ aVisitor visitBPSimVendorExtension: self! !

A4BPAbstractParser subclass: #BPSimParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser'!

!BPSimParser methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:03'!
bpsimdata
	^ lstElements ! !

!BPSimParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:03'!
filePrefix
	^ '.bpmn'! !

!BPSimParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:05'!
getBaseElement
	^ BPSimData! !

!BPSimParser methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:05'!
initialize
	super initialize ! !

!BPSimParser methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 14:48'!
parseStream: stream
	| document data lst|
	document := (XMLDOMParser on: stream) parseDocument.
	data := document allElementsNamed: 'bpsim:BPSimData'.
	lst := OrderedCollection new.
	data do: [ :xmlDescription | lst add: (BPSimData fromXMLDescription: xmlDescription) ].
	^ lst first! !

!BPSimParser methodsFor: 'parser' stamp: 'SergeStinckwich 3/6/2015 15:22'!
parseString: string
	^ self parseStream:  (ReadStream on: string)! !

A4BPParserTagsXMLRef subclass: #BPSimParserTagsXMLRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser'!

!BPSimParserTagsXMLRef class methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:16'!
copyList: lstItems with: v
	"second model option bpmn:<tag>"
	lstItems copy do:[ :i |
		lstItems add: (A4BPParserRefTagClass getRefOnTag: ( v, i tag) objClass: (i objclass) ). 
	].
	
	^ lstItems! !

!BPSimParserTagsXMLRef class methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:19'!
fillTags
	tags addAll: self lstOfRefTagClass.
	^ tags! !

!BPSimParserTagsXMLRef class methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:37'!
lstOfRefTagClass
	
	"self reset"

	|items|
	items := Dictionary new.
	
	"
	using 
	self fillItems: items tag: tag class: objClass
	to add items to parse the object
	"
	self fillItems: items tag: 'ScenarioParameters' class: BPSimScenarioParameters.
	self fillItems: items tag: 'Scenario' class: BPSimScenario.
	self fillItems: items tag: 'Duration' class: BPSimDuration.
	self fillItems: items tag: 'DurationParameter' class: BPSimDurationParameter.
	
	self copyList: items with:'bpsim:'.
	
	^ items! !

!BPSimParserTagsXMLRef class methodsFor: 'resetting' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:16'!
reset
	"self reset"
	tags := nil.
	^ 'OK'! !

TestCase subclass: #BPSimParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-Tests'!

!BPSimParserTest commentStamp: '<historical>' prior: 0!
A BPSimParserTest is a test class for testing the behavior of BPSimParser!

!BPSimParserTest class methodsFor: 'examples' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:09'!
example2
^'<?xml version="1.0" encoding="ISO-8859-1" standalone="yes"?>
<bpmn:definitions id="_1364754643385" name="Loan Process v0.20" targetNamespace="http://www.trisotech.com/definitions/_1364754643385" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:bpsim="http://www.bpsim.org/schemas/1.0" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <bpmn:message id="_1364754643401"/>
    <bpmn:message id="_1364754643403"/>
    <bpmn:message id="_1364754643417"/>
    <bpmn:message id="_1364754643422"/>
    <bpmn:message id="_1364754643428"/>
    <bpmn:process isExecutable="false" id="_6">
        <bpmn:laneSet id="ls_1364754643532">
            <bpmn:lane name="Loan officer" id="_81354509-EC39-44E5-A266-4286CBB1EFAC">
                <bpmn:flowNodeRef>_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_8576B2C5-068B-4A21-A035-A3F55CA7AA70</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_C94EFA57-E605-4564-BFC4-22A84C660A6A</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_DA142784-0125-46E0-A3CA-004302BD5E21</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_63474DBF-E8E4-4C29-AD38-E46DE50EE080</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_6E1A332C-9187-4C4A-BD0F-27167F940786</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_2017EC19-4BD5-40D7-9014-E7D337A68E01</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_65F6E8B9-FDD3-4770-B12B-87862F37BDF6</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_D6383F72-7F7A-48F8-A742-A26F36A8DC10</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_F366069F-C180-4D69-B2BF-4124649EC36F</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_C77E51FD-9C1B-40F7-9273-100E47069B11</bpmn:flowNodeRef>
            </bpmn:lane>
            <bpmn:lane name="Title Researcher" id="_B634801B-C2C5-4C55-A4AD-17882B1E87F2">
                <bpmn:flowNodeRef>_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_ACDC390F-49FD-43A3-ACD6-1EBB8074801D</bpmn:flowNodeRef>
            </bpmn:lane>
            <bpmn:lane name="Loan Underwriter" id="_357D85DD-EB4D-4D21-AAD7-D9895DA1633B">
                <bpmn:flowNodeRef>_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_32AE6A44-B449-40FE-9055-69819469BF98</bpmn:flowNodeRef>
                <bpmn:flowNodeRef>_57EE71B2-5287-46A2-9B24-83A68131714C</bpmn:flowNodeRef>
            </bpmn:lane>
        </bpmn:laneSet>
        <bpmn:dataObject isCollection="false" id="DF1364754643533"/>
        <bpmn:startEvent name="Receive  Loan  Application" id="_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0">
            <bpmn:outgoing>_72A5DDBE-554D-4014-BE8C-FB2E7642F4C3</bpmn:outgoing>
            <bpmn:dataOutput id="Dout1364754643587"/>
            <bpmn:dataOutputAssociation id="_5D0B2CCB-8CD7-4D85-B56B-2095BDBF6240">
                <bpmn:sourceRef>Dout1364754643587</bpmn:sourceRef>
                <bpmn:targetRef>_F36BDDC0-AD29-47B6-8102-9BF334EFB012</bpmn:targetRef>
            </bpmn:dataOutputAssociation>
            <bpmn:outputSet>
                <bpmn:dataOutputRefs>Dout1364754643587</bpmn:dataOutputRefs>
            </bpmn:outputSet>
            <bpmn:messageEventDefinition messageRef="_1364754643401"/>
        </bpmn:startEvent>
        <bpmn:intermediateThrowEvent name="Request Credit Report" id="_8576B2C5-068B-4A21-A035-A3F55CA7AA70">
            <bpmn:incoming>_F39FB372-FB0E-475E-8174-D9F6C1EFABA9</bpmn:incoming>
            <bpmn:outgoing>_2DC8CE0B-492C-4326-A36C-FA37E695F6B8</bpmn:outgoing>
            <bpmn:messageEventDefinition messageRef="_1364754643403"/>
        </bpmn:intermediateThrowEvent>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Verify Employment" id="_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A">
            <bpmn:incoming>_4300C232-1B1B-4D7D-9056-A153E31A2A5E</bpmn:incoming>
            <bpmn:outgoing>_8663B922-4BE9-4192-8BC8-0578B127A8F1</bpmn:outgoing>
        </bpmn:userTask>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Review Loan Application" id="_C94EFA57-E605-4564-BFC4-22A84C660A6A">
            <bpmn:incoming>_B9562572-75E4-4143-BC81-4D79CEDB65D6</bpmn:incoming>
            <bpmn:outgoing>_A80D6FF4-D222-4AAF-9161-8FB83F91AEED</bpmn:outgoing>
        </bpmn:userTask>
        <bpmn:parallelGateway gatewayDirection="Unspecified" name="" id="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4">
            <bpmn:incoming>_0E7BF85E-0000-43F9-B735-3BF726227B81</bpmn:incoming>
            <bpmn:outgoing>_4300C232-1B1B-4D7D-9056-A153E31A2A5E</bpmn:outgoing>
            <bpmn:outgoing>_F39FB372-FB0E-475E-8174-D9F6C1EFABA9</bpmn:outgoing>
            <bpmn:outgoing>_880E2204-2897-40BA-9C2F-B81F9580EF75</bpmn:outgoing>
        </bpmn:parallelGateway>
        <bpmn:sendTask implementation="##WebService" messageRef="_1364754643417" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Send Approval Letter" id="_DA142784-0125-46E0-A3CA-004302BD5E21">
            <bpmn:incoming>_3D6F2455-BFFB-44BB-A052-892FB15FEEB4</bpmn:incoming>
            <bpmn:outgoing>_906AE477-1AA9-443C-AFFD-C0F2AAE20D83</bpmn:outgoing>
        </bpmn:sendTask>
        <bpmn:endEvent name="Loan Request Rejected" id="_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB">
            <bpmn:incoming>_0AEB1821-0E16-4CC8-BC7C-9AF71C35F88F</bpmn:incoming>
        </bpmn:endEvent>
        <bpmn:exclusiveGateway gatewayDirection="Unspecified" name="Approved?" id="_63474DBF-E8E4-4C29-AD38-E46DE50EE080">
            <bpmn:incoming>_A80D6FF4-D222-4AAF-9161-8FB83F91AEED</bpmn:incoming>
            <bpmn:outgoing>_93351D59-990B-46B0-80AB-FEEF088E9D7B</bpmn:outgoing>
            <bpmn:outgoing>_3D6F2455-BFFB-44BB-A052-892FB15FEEB4</bpmn:outgoing>
        </bpmn:exclusiveGateway>
        <bpmn:intermediateCatchEvent parallelMultiple="false" name="Receive  Credit  Report" id="_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE">
            <bpmn:incoming>_2DC8CE0B-492C-4326-A36C-FA37E695F6B8</bpmn:incoming>
            <bpmn:outgoing>_D8676C4E-977F-4441-B9AA-9E0F82898D34</bpmn:outgoing>
            <bpmn:messageEventDefinition messageRef="_1364754643422"/>
        </bpmn:intermediateCatchEvent>
        <bpmn:endEvent name="Loan Request Approved" id="_6E1A332C-9187-4C4A-BD0F-27167F940786">
            <bpmn:incoming>_DEAA6495-03EC-479A-BAED-836083B9B19F</bpmn:incoming>
        </bpmn:endEvent>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Record Loan Application" id="_2017EC19-4BD5-40D7-9014-E7D337A68E01">
            <bpmn:incoming>_72A5DDBE-554D-4014-BE8C-FB2E7642F4C3</bpmn:incoming>
            <bpmn:outgoing>_0E7BF85E-0000-43F9-B735-3BF726227B81</bpmn:outgoing>
            <bpmn:ioSpecification>
                <bpmn:dataInput id="Din1364754643584"/>
                <bpmn:inputSet>
                    <bpmn:dataInputRefs>Din1364754643584</bpmn:dataInputRefs>
                </bpmn:inputSet>
                <bpmn:outputSet/>
            </bpmn:ioSpecification>
            <bpmn:dataInputAssociation id="_8BF5972D-13A9-4941-A60A-F338F0347B05">
                <bpmn:sourceRef>_F36BDDC0-AD29-47B6-8102-9BF334EFB012</bpmn:sourceRef>
                <bpmn:targetRef>Din1364754643584</bpmn:targetRef>
            </bpmn:dataInputAssociation>
        </bpmn:userTask>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Close-Out Rejection" id="_65F6E8B9-FDD3-4770-B12B-87862F37BDF6">
            <bpmn:incoming>_07B03EA5-891A-4BF5-8779-1A6912D3B183</bpmn:incoming>
            <bpmn:outgoing>_0AEB1821-0E16-4CC8-BC7C-9AF71C35F88F</bpmn:outgoing>
            <bpmn:ioSpecification>
                <bpmn:dataOutput id="Dout1364754643585"/>
                <bpmn:inputSet/>
                <bpmn:outputSet>
                    <bpmn:dataOutputRefs>Dout1364754643585</bpmn:dataOutputRefs>
                </bpmn:outputSet>
            </bpmn:ioSpecification>
            <bpmn:dataOutputAssociation id="_346DBF5F-09DC-4A36-95E4-5019CA5D6457">
                <bpmn:sourceRef>Dout1364754643585</bpmn:sourceRef>
                <bpmn:targetRef>_676BDDAC-A319-426B-96DF-E1F1EEF38EFB</bpmn:targetRef>
            </bpmn:dataOutputAssociation>
        </bpmn:userTask>
        <bpmn:sendTask implementation="##WebService" messageRef="_1364754643428" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Send Rejection Letter" id="_D6383F72-7F7A-48F8-A742-A26F36A8DC10">
            <bpmn:incoming>_93351D59-990B-46B0-80AB-FEEF088E9D7B</bpmn:incoming>
            <bpmn:outgoing>_07B03EA5-891A-4BF5-8779-1A6912D3B183</bpmn:outgoing>
        </bpmn:sendTask>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Close-out Approval" id="_F366069F-C180-4D69-B2BF-4124649EC36F">
            <bpmn:incoming>_BCC30BA7-C001-4D9D-B69C-2D99DA0706C5</bpmn:incoming>
            <bpmn:outgoing>_DEAA6495-03EC-479A-BAED-836083B9B19F</bpmn:outgoing>
            <bpmn:ioSpecification>
                <bpmn:dataOutput id="Dout1364754643586"/>
                <bpmn:inputSet/>
                <bpmn:outputSet>
                    <bpmn:dataOutputRefs>Dout1364754643586</bpmn:dataOutputRefs>
                </bpmn:outputSet>
            </bpmn:ioSpecification>
            <bpmn:dataOutputAssociation id="_95613936-EA5E-432B-8F84-5D29E58EA82F">
                <bpmn:sourceRef>Dout1364754643586</bpmn:sourceRef>
                <bpmn:targetRef>_A383CA8A-59EA-4E2E-8A40-38363ACF6547</bpmn:targetRef>
            </bpmn:dataOutputAssociation>
        </bpmn:userTask>
        <bpmn:parallelGateway gatewayDirection="Unspecified" name="" id="_C77E51FD-9C1B-40F7-9273-100E47069B11">
            <bpmn:incoming>_D8676C4E-977F-4441-B9AA-9E0F82898D34</bpmn:incoming>
            <bpmn:incoming>_8663B922-4BE9-4192-8BC8-0578B127A8F1</bpmn:incoming>
            <bpmn:incoming>_78F951B5-7470-4538-AA6C-CD08E4D422C6</bpmn:incoming>
            <bpmn:outgoing>_B9562572-75E4-4143-BC81-4D79CEDB65D6</bpmn:outgoing>
        </bpmn:parallelGateway>
        <bpmn:manualTask completionQuantity="1" isForCompensation="false" startQuantity="1" name="Perform Title Search" id="_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316">
            <bpmn:incoming>_880E2204-2897-40BA-9C2F-B81F9580EF75</bpmn:incoming>
            <bpmn:outgoing>_60D986A6-6530-4D75-9648-AF5AFB1CA9A6</bpmn:outgoing>
        </bpmn:manualTask>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Review Title Report" id="_ACDC390F-49FD-43A3-ACD6-1EBB8074801D">
            <bpmn:incoming>_60D986A6-6530-4D75-9648-AF5AFB1CA9A6</bpmn:incoming>
            <bpmn:outgoing>_78F951B5-7470-4538-AA6C-CD08E4D422C6</bpmn:outgoing>
        </bpmn:userTask>
        <bpmn:scriptTask completionQuantity="1" isForCompensation="false" startQuantity="1" name="Set with Default Terms" id="_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D">
            <bpmn:incoming>_F36A03D5-2835-4BEB-9835-612961CB01B0</bpmn:incoming>
            <bpmn:outgoing>_81B53174-A333-4892-8A4E-0654D0DC9059</bpmn:outgoing>
            <bpmn:script/>
        </bpmn:scriptTask>
        <bpmn:exclusiveGateway gatewayDirection="Unspecified" name="" id="_32AE6A44-B449-40FE-9055-69819469BF98">
            <bpmn:incoming>_F8D6251D-FEDF-40FE-9541-89714A5F81D8</bpmn:incoming>
            <bpmn:incoming>_81B53174-A333-4892-8A4E-0654D0DC9059</bpmn:incoming>
            <bpmn:outgoing>_BCC30BA7-C001-4D9D-B69C-2D99DA0706C5</bpmn:outgoing>
        </bpmn:exclusiveGateway>
        <bpmn:userTask implementation="##WebService" completionQuantity="1" isForCompensation="false" startQuantity="1" name="Underwrite Loan with Terms" id="_57EE71B2-5287-46A2-9B24-83A68131714C">
            <bpmn:incoming>_906AE477-1AA9-443C-AFFD-C0F2AAE20D83</bpmn:incoming>
            <bpmn:outgoing>_F8D6251D-FEDF-40FE-9541-89714A5F81D8</bpmn:outgoing>
        </bpmn:userTask>
        <bpmn:boundaryEvent attachedToRef="_57EE71B2-5287-46A2-9B24-83A68131714C" cancelActivity="true" parallelMultiple="false" name="1 Hour Time Limit" id="_542AE8E6-9CEA-43E3-8177-C685A9F430FE">
            <bpmn:outgoing>_F36A03D5-2835-4BEB-9835-612961CB01B0</bpmn:outgoing>
            <bpmn:timerEventDefinition>
                <bpmn:timeDate/>
            </bpmn:timerEventDefinition>
        </bpmn:boundaryEvent>
        <bpmn:dataObjectReference dataObjectRef="DF1364754643533" name="Loan Application" id="_A383CA8A-59EA-4E2E-8A40-38363ACF6547">
            <bpmn:dataState name="Approved"/>
        </bpmn:dataObjectReference>
        <bpmn:dataObjectReference dataObjectRef="DF1364754643533" name="Loan Application" id="_F36BDDC0-AD29-47B6-8102-9BF334EFB012">
            <bpmn:dataState name="Initial"/>
        </bpmn:dataObjectReference>
        <bpmn:dataObjectReference dataObjectRef="DF1364754643533" name="Loan Application" id="_676BDDAC-A319-426B-96DF-E1F1EEF38EFB">
            <bpmn:dataState name="Rejected"/>
        </bpmn:dataObjectReference>
        <bpmn:sequenceFlow sourceRef="_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0" targetRef="_2017EC19-4BD5-40D7-9014-E7D337A68E01" name="" id="_72A5DDBE-554D-4014-BE8C-FB2E7642F4C3"/>
        <bpmn:sequenceFlow sourceRef="_2017EC19-4BD5-40D7-9014-E7D337A68E01" targetRef="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4" name="" id="_0E7BF85E-0000-43F9-B735-3BF726227B81"/>
        <bpmn:sequenceFlow sourceRef="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4" targetRef="_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A" name="" id="_4300C232-1B1B-4D7D-9056-A153E31A2A5E"/>
        <bpmn:sequenceFlow sourceRef="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4" targetRef="_8576B2C5-068B-4A21-A035-A3F55CA7AA70" name="" id="_F39FB372-FB0E-475E-8174-D9F6C1EFABA9"/>
        <bpmn:sequenceFlow sourceRef="_8576B2C5-068B-4A21-A035-A3F55CA7AA70" targetRef="_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE" name="" id="_2DC8CE0B-492C-4326-A36C-FA37E695F6B8"/>
        <bpmn:sequenceFlow sourceRef="_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE" targetRef="_C77E51FD-9C1B-40F7-9273-100E47069B11" name="" id="_D8676C4E-977F-4441-B9AA-9E0F82898D34"/>
        <bpmn:sequenceFlow sourceRef="_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A" targetRef="_C77E51FD-9C1B-40F7-9273-100E47069B11" name="" id="_8663B922-4BE9-4192-8BC8-0578B127A8F1"/>
        <bpmn:sequenceFlow sourceRef="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4" targetRef="_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316" name="" id="_880E2204-2897-40BA-9C2F-B81F9580EF75"/>
        <bpmn:sequenceFlow sourceRef="_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316" targetRef="_ACDC390F-49FD-43A3-ACD6-1EBB8074801D" name="" id="_60D986A6-6530-4D75-9648-AF5AFB1CA9A6"/>
        <bpmn:sequenceFlow sourceRef="_ACDC390F-49FD-43A3-ACD6-1EBB8074801D" targetRef="_C77E51FD-9C1B-40F7-9273-100E47069B11" name="" id="_78F951B5-7470-4538-AA6C-CD08E4D422C6"/>
        <bpmn:sequenceFlow sourceRef="_C77E51FD-9C1B-40F7-9273-100E47069B11" targetRef="_C94EFA57-E605-4564-BFC4-22A84C660A6A" name="" id="_B9562572-75E4-4143-BC81-4D79CEDB65D6"/>
        <bpmn:sequenceFlow sourceRef="_C94EFA57-E605-4564-BFC4-22A84C660A6A" targetRef="_63474DBF-E8E4-4C29-AD38-E46DE50EE080" name="" id="_A80D6FF4-D222-4AAF-9161-8FB83F91AEED"/>
        <bpmn:sequenceFlow sourceRef="_63474DBF-E8E4-4C29-AD38-E46DE50EE080" targetRef="_D6383F72-7F7A-48F8-A742-A26F36A8DC10" name="No" id="_93351D59-990B-46B0-80AB-FEEF088E9D7B"/>
        <bpmn:sequenceFlow sourceRef="_D6383F72-7F7A-48F8-A742-A26F36A8DC10" targetRef="_65F6E8B9-FDD3-4770-B12B-87862F37BDF6" name="" id="_07B03EA5-891A-4BF5-8779-1A6912D3B183"/>
        <bpmn:sequenceFlow sourceRef="_65F6E8B9-FDD3-4770-B12B-87862F37BDF6" targetRef="_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB" name="" id="_0AEB1821-0E16-4CC8-BC7C-9AF71C35F88F"/>
        <bpmn:sequenceFlow sourceRef="_63474DBF-E8E4-4C29-AD38-E46DE50EE080" targetRef="_DA142784-0125-46E0-A3CA-004302BD5E21" name="Yes" id="_3D6F2455-BFFB-44BB-A052-892FB15FEEB4"/>
        <bpmn:sequenceFlow sourceRef="_DA142784-0125-46E0-A3CA-004302BD5E21" targetRef="_57EE71B2-5287-46A2-9B24-83A68131714C" name="" id="_906AE477-1AA9-443C-AFFD-C0F2AAE20D83"/>
        <bpmn:sequenceFlow sourceRef="_57EE71B2-5287-46A2-9B24-83A68131714C" targetRef="_32AE6A44-B449-40FE-9055-69819469BF98" name="" id="_F8D6251D-FEDF-40FE-9541-89714A5F81D8"/>
        <bpmn:sequenceFlow sourceRef="_542AE8E6-9CEA-43E3-8177-C685A9F430FE" targetRef="_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D" name="" id="_F36A03D5-2835-4BEB-9835-612961CB01B0"/>
        <bpmn:sequenceFlow sourceRef="_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D" targetRef="_32AE6A44-B449-40FE-9055-69819469BF98" name="" id="_81B53174-A333-4892-8A4E-0654D0DC9059"/>
        <bpmn:sequenceFlow sourceRef="_32AE6A44-B449-40FE-9055-69819469BF98" targetRef="_F366069F-C180-4D69-B2BF-4124649EC36F" name="" id="_BCC30BA7-C001-4D9D-B69C-2D99DA0706C5"/>
        <bpmn:sequenceFlow sourceRef="_F366069F-C180-4D69-B2BF-4124649EC36F" targetRef="_6E1A332C-9187-4C4A-BD0F-27167F940786" name="" id="_DEAA6495-03EC-479A-BAED-836083B9B19F"/>
    </bpmn:process>
    <bpmndi:BPMNDiagram documentation="" id="Trisotech_Visio-_6" name="Loan Origination" resolution="96.00000267028808">
        <bpmndi:BPMNPlane bpmnElement="_6">
            <bpmndi:BPMNShape bpmnElement="_81354509-EC39-44E5-A266-4286CBB1EFAC" isHorizontal="true" id="S1364754643557__81354509-EC39-44E5-A266-4286CBB1EFAC">
                <dc:Bounds height="471.0" width="1524.0" x="384.0" y="120.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_B634801B-C2C5-4C55-A4AD-17882B1E87F2" isHorizontal="true" id="S1364754643558__B634801B-C2C5-4C55-A4AD-17882B1E87F2">
                <dc:Bounds height="168.0" width="1524.0" x="384.0" y="591.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_357D85DD-EB4D-4D21-AAD7-D9895DA1633B" isHorizontal="true" id="S1364754643559__357D85DD-EB4D-4D21-AAD7-D9895DA1633B">
                <dc:Bounds height="282.0" width="1524.0" x="384.0" y="759.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0" id="S1364754643560__4E504F9B-2618-424F-ABAA-C4D4CC2D75E0">
                <dc:Bounds height="30.0" width="30.0" x="470.0" y="315.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_8576B2C5-068B-4A21-A035-A3F55CA7AA70" id="S1364754643561__8576B2C5-068B-4A21-A035-A3F55CA7AA70">
                <dc:Bounds height="32.0" width="32.0" x="818.0" y="314.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A" id="S1364754643562__0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A">
                <dc:Bounds height="68.0" width="105.0" x="830.0" y="171.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_C94EFA57-E605-4564-BFC4-22A84C660A6A" id="S1364754643563__C94EFA57-E605-4564-BFC4-22A84C660A6A">
                <dc:Bounds height="68.0" width="105.0" x="1137.0" y="296.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_D94158CC-F5C2-46A2-96A2-CD8B02AF14B4" id="S1364754643564__D94158CC-F5C2-46A2-96A2-CD8B02AF14B4">
                <dc:Bounds height="42.0" width="42.0" x="705.0" y="309.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_DA142784-0125-46E0-A3CA-004302BD5E21" id="S1364754643565__DA142784-0125-46E0-A3CA-004302BD5E21">
                <dc:Bounds height="68.0" width="105.0" x="1405.0" y="388.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB" id="S1364754643566__A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB">
                <dc:Bounds height="32.0" width="32.0" x="1818.0" y="189.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_63474DBF-E8E4-4C29-AD38-E46DE50EE080" isMarkerVisible="true" id="S1364754643567__63474DBF-E8E4-4C29-AD38-E46DE50EE080">
                <dc:Bounds height="42.0" width="42.0" x="1293.0" y="309.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE" id="S1364754643568__BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE">
                <dc:Bounds height="32.0" width="32.0" x="940.0" y="314.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_6E1A332C-9187-4C4A-BD0F-27167F940786" id="S1364754643569__6E1A332C-9187-4C4A-BD0F-27167F940786">
                <dc:Bounds height="32.0" width="32.0" x="1818.0" y="411.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_2017EC19-4BD5-40D7-9014-E7D337A68E01" id="S1364754643570__2017EC19-4BD5-40D7-9014-E7D337A68E01">
                <dc:Bounds height="68.0" width="105.0" x="549.0" y="296.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_65F6E8B9-FDD3-4770-B12B-87862F37BDF6" id="S1364754643571__65F6E8B9-FDD3-4770-B12B-87862F37BDF6">
                <dc:Bounds height="68.0" width="105.0" x="1663.0" y="171.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_D6383F72-7F7A-48F8-A742-A26F36A8DC10" id="S1364754643572__D6383F72-7F7A-48F8-A742-A26F36A8DC10">
                <dc:Bounds height="68.0" width="105.0" x="1404.0" y="171.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_F366069F-C180-4D69-B2BF-4124649EC36F" id="S1364754643573__F366069F-C180-4D69-B2BF-4124649EC36F">
                <dc:Bounds height="68.0" width="105.0" x="1664.0" y="393.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_C77E51FD-9C1B-40F7-9273-100E47069B11" id="S1364754643574__C77E51FD-9C1B-40F7-9273-100E47069B11">
                <dc:Bounds height="42.0" width="42.0" x="1044.0" y="309.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316" id="S1364754643575__4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316">
                <dc:Bounds height="68.0" width="105.0" x="780.0" y="639.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_ACDC390F-49FD-43A3-ACD6-1EBB8074801D" id="S1364754643576__ACDC390F-49FD-43A3-ACD6-1EBB8074801D">
                <dc:Bounds height="68.0" width="105.0" x="930.0" y="639.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D" id="S1364754643577__3330ACC4-BCD9-422A-ADCD-7DDF06A2042D">
                <dc:Bounds height="68.0" width="105.0" x="1563.0" y="931.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_32AE6A44-B449-40FE-9055-69819469BF98" isMarkerVisible="true" id="S1364754643578__32AE6A44-B449-40FE-9055-69819469BF98">
                <dc:Bounds height="42.0" width="42.0" x="1595.0" y="839.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_57EE71B2-5287-46A2-9B24-83A68131714C" id="S1364754643579__57EE71B2-5287-46A2-9B24-83A68131714C">
                <dc:Bounds height="68.0" width="105.0" x="1405.0" y="825.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_542AE8E6-9CEA-43E3-8177-C685A9F430FE" id="S1364754643580__542AE8E6-9CEA-43E3-8177-C685A9F430FE">
                <dc:Bounds height="32.0" width="32.0" x="1416.0" y="877.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_A383CA8A-59EA-4E2E-8A40-38363ACF6547" id="S1364754643581__A383CA8A-59EA-4E2E-8A40-38363ACF6547">
                <dc:Bounds height="38.0" width="30.0" x="1738.0" y="489.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_F36BDDC0-AD29-47B6-8102-9BF334EFB012" id="S1364754643582__F36BDDC0-AD29-47B6-8102-9BF334EFB012">
                <dc:Bounds height="38.0" width="30.0" x="534.0" y="187.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNShape bpmnElement="_676BDDAC-A319-426B-96DF-E1F1EEF38EFB" id="S1364754643583__676BDDAC-A319-426B-96DF-E1F1EEF38EFB">
                <dc:Bounds height="38.0" width="30.0" x="1738.0" y="262.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNShape>
            <bpmndi:BPMNEdge bpmnElement="_8BF5972D-13A9-4941-A60A-F338F0347B05" targetElement="S1364754643570__2017EC19-4BD5-40D7-9014-E7D337A68E01" id="E1364754643589__8BF5972D-13A9-4941-A60A-F338F0347B05">
                <di:waypoint x="564.0" y="205.0"/>
                <di:waypoint x="601.0" y="205.0"/>
                <di:waypoint x="602.0" y="296.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_81B53174-A333-4892-8A4E-0654D0DC9059" id="E1364754643590__81B53174-A333-4892-8A4E-0654D0DC9059">
                <di:waypoint x="1616.0" y="931.0"/>
                <di:waypoint x="1616.0" y="917.0"/>
                <di:waypoint x="1616.0" y="880.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_0E7BF85E-0000-43F9-B735-3BF726227B81" id="E1364754643591__0E7BF85E-0000-43F9-B735-3BF726227B81">
                <di:waypoint x="654.0" y="330.0"/>
                <di:waypoint x="668.0" y="330.0"/>
                <di:waypoint x="705.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_60D986A6-6530-4D75-9648-AF5AFB1CA9A6" id="E1364754643592__60D986A6-6530-4D75-9648-AF5AFB1CA9A6">
                <di:waypoint x="885.0" y="673.0"/>
                <di:waypoint x="930.0" y="673.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_72A5DDBE-554D-4014-BE8C-FB2E7642F4C3" id="E1364754643593__72A5DDBE-554D-4014-BE8C-FB2E7642F4C3">
                <di:waypoint x="500.0" y="330.0"/>
                <di:waypoint x="514.0" y="330.0"/>
                <di:waypoint x="549.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_8663B922-4BE9-4192-8BC8-0578B127A8F1" id="E1364754643594__8663B922-4BE9-4192-8BC8-0578B127A8F1">
                <di:waypoint x="935.0" y="205.0"/>
                <di:waypoint x="1065.0" y="205.0"/>
                <di:waypoint x="1065.0" y="309.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_DEAA6495-03EC-479A-BAED-836083B9B19F" id="E1364754643595__DEAA6495-03EC-479A-BAED-836083B9B19F">
                <di:waypoint x="1769.0" y="427.0"/>
                <di:waypoint x="1783.0" y="427.0"/>
                <di:waypoint x="1818.0" y="427.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_346DBF5F-09DC-4A36-95E4-5019CA5D6457" sourceElement="S1364754643571__65F6E8B9-FDD3-4770-B12B-87862F37BDF6" id="E1364754643596__346DBF5F-09DC-4A36-95E4-5019CA5D6457">
                <di:waypoint x="1698.0" y="239.0"/>
                <di:waypoint x="1698.0" y="280.0"/>
                <di:waypoint x="1738.0" y="281.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_BCC30BA7-C001-4D9D-B69C-2D99DA0706C5" id="E1364754643597__BCC30BA7-C001-4D9D-B69C-2D99DA0706C5">
                <di:waypoint x="1616.0" y="839.0"/>
                <di:waypoint x="1616.0" y="427.0"/>
                <di:waypoint x="1664.0" y="427.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_93351D59-990B-46B0-80AB-FEEF088E9D7B" id="E1364754643598__93351D59-990B-46B0-80AB-FEEF088E9D7B">
                <di:waypoint x="1314.0" y="309.0"/>
                <di:waypoint x="1314.0" y="205.0"/>
                <di:waypoint x="1404.0" y="205.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_A80D6FF4-D222-4AAF-9161-8FB83F91AEED" id="E1364754643599__A80D6FF4-D222-4AAF-9161-8FB83F91AEED">
                <di:waypoint x="1242.0" y="330.0"/>
                <di:waypoint x="1256.0" y="330.0"/>
                <di:waypoint x="1293.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_F39FB372-FB0E-475E-8174-D9F6C1EFABA9" id="E1364754643600__F39FB372-FB0E-475E-8174-D9F6C1EFABA9">
                <di:waypoint x="747.0" y="330.0"/>
                <di:waypoint x="818.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_F8D6251D-FEDF-40FE-9541-89714A5F81D8" id="E1364754643601__F8D6251D-FEDF-40FE-9541-89714A5F81D8">
                <di:waypoint x="1510.0" y="859.0"/>
                <di:waypoint x="1524.0" y="859.0"/>
                <di:waypoint x="1595.0" y="859.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_07B03EA5-891A-4BF5-8779-1A6912D3B183" id="E1364754643602__07B03EA5-891A-4BF5-8779-1A6912D3B183">
                <di:waypoint x="1509.0" y="205.0"/>
                <di:waypoint x="1663.0" y="205.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_5D0B2CCB-8CD7-4D85-B56B-2095BDBF6240" sourceElement="S1364754643560__4E504F9B-2618-424F-ABAA-C4D4CC2D75E0" id="E1364754643603__5D0B2CCB-8CD7-4D85-B56B-2095BDBF6240">
                <di:waypoint x="485.0" y="315.0"/>
                <di:waypoint x="485.0" y="206.0"/>
                <di:waypoint x="534.0" y="205.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_0AEB1821-0E16-4CC8-BC7C-9AF71C35F88F" id="E1364754643604__0AEB1821-0E16-4CC8-BC7C-9AF71C35F88F">
                <di:waypoint x="1768.0" y="205.0"/>
                <di:waypoint x="1782.0" y="205.0"/>
                <di:waypoint x="1818.0" y="205.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_880E2204-2897-40BA-9C2F-B81F9580EF75" id="E1364754643605__880E2204-2897-40BA-9C2F-B81F9580EF75">
                <di:waypoint x="726.0" y="351.0"/>
                <di:waypoint x="726.0" y="674.0"/>
                <di:waypoint x="780.0" y="673.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_4300C232-1B1B-4D7D-9056-A153E31A2A5E" id="E1364754643606__4300C232-1B1B-4D7D-9056-A153E31A2A5E">
                <di:waypoint x="730.0" y="313.0"/>
                <di:waypoint x="730.0" y="205.0"/>
                <di:waypoint x="830.0" y="205.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_F36A03D5-2835-4BEB-9835-612961CB01B0" id="E1364754643607__F36A03D5-2835-4BEB-9835-612961CB01B0">
                <di:waypoint x="1432.0" y="909.0"/>
                <di:waypoint x="1432.0" y="945.0"/>
                <di:waypoint x="1563.0" y="945.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_906AE477-1AA9-443C-AFFD-C0F2AAE20D83" id="E1364754643608__906AE477-1AA9-443C-AFFD-C0F2AAE20D83">
                <di:waypoint x="1457.0" y="456.0"/>
                <di:waypoint x="1457.0" y="825.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_D8676C4E-977F-4441-B9AA-9E0F82898D34" id="E1364754643609__D8676C4E-977F-4441-B9AA-9E0F82898D34">
                <di:waypoint x="973.0" y="330.0"/>
                <di:waypoint x="1044.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_3D6F2455-BFFB-44BB-A052-892FB15FEEB4" id="E1364754643610__3D6F2455-BFFB-44BB-A052-892FB15FEEB4">
                <di:waypoint x="1314.0" y="351.0"/>
                <di:waypoint x="1314.0" y="422.0"/>
                <di:waypoint x="1405.0" y="422.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_78F951B5-7470-4538-AA6C-CD08E4D422C6" id="E1364754643611__78F951B5-7470-4538-AA6C-CD08E4D422C6">
                <di:waypoint x="1035.0" y="673.0"/>
                <di:waypoint x="1065.0" y="673.0"/>
                <di:waypoint x="1065.0" y="351.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_2DC8CE0B-492C-4326-A36C-FA37E695F6B8" id="E1364754643612__2DC8CE0B-492C-4326-A36C-FA37E695F6B8">
                <di:waypoint x="850.0" y="330.0"/>
                <di:waypoint x="940.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_95613936-EA5E-432B-8F84-5D29E58EA82F" sourceElement="S1364754643573__F366069F-C180-4D69-B2BF-4124649EC36F" id="E1364754643613__95613936-EA5E-432B-8F84-5D29E58EA82F">
                <di:waypoint x="1716.0" y="461.0"/>
                <di:waypoint x="1716.0" y="508.0"/>
                <di:waypoint x="1738.0" y="507.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
            <bpmndi:BPMNEdge bpmnElement="_B9562572-75E4-4143-BC81-4D79CEDB65D6" id="E1364754643614__B9562572-75E4-4143-BC81-4D79CEDB65D6">
                <di:waypoint x="1086.0" y="330.0"/>
                <di:waypoint x="1100.0" y="330.0"/>
                <di:waypoint x="1137.0" y="330.0"/>
                <bpmndi:BPMNLabel/>
            </bpmndi:BPMNEdge>
        </bpmndi:BPMNPlane>
    </bpmndi:BPMNDiagram>
    <bpmn:relationship type="BPSimData">
        <bpmn:extensionElements>
            <bpsim:BPSimData>
                <bpsim:Scenario author="Tim Stephenson" id="default" name="Scenario 1">
                    <bpsim:ScenarioParameters baseTimeUnit="min" replication="3">
                        <bpsim:Duration>
                            <bpsim:DurationParameter value="PT40H"/>
                        </bpsim:Duration>
                    </bpsim:ScenarioParameters>
                    <bpsim:ElementParameters elementRef="_6">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                        <bpsim:ControlParameters>
                            <bpsim:TriggerCount>
                                <bpsim:ResultRequest>count</bpsim:ResultRequest>
                            </bpsim:TriggerCount>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0">
                        <bpsim:ControlParameters>
                            <bpsim:InterTriggerTimer>
                                <bpsim:TriangularDistribution max="30" min="10" mode="16"/>
                            </bpsim:InterTriggerTimer>
                            <bpsim:TriggerCount>
                                <bpsim:ResultRequest>count</bpsim:ResultRequest>
                            </bpsim:TriggerCount>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:TriangularDistribution max="6" min="4" mode="5"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                        <bpsim:ControlParameters>
                            <bpsim:InterTriggerTimer>
                                <bpsim:TriangularDistribution max="6" min="4" mode="5"/>
                            </bpsim:InterTriggerTimer>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_2017EC19-4BD5-40D7-9014-E7D337A68E01">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="20" min="0" standardDeviation="1"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="30" min="0" standardDeviation="4"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="60" min="0" standardDeviation="2"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_ACDC390F-49FD-43A3-ACD6-1EBB8074801D">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="20" min="0" standardDeviation="2"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_C94EFA57-E605-4564-BFC4-22A84C660A6A">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="30" min="0" standardDeviation="4"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_65F6E8B9-FDD3-4770-B12B-87862F37BDF6">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="5" min="0" standardDeviation="0.25"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_F366069F-C180-4D69-B2BF-4124649EC36F">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="10" min="0" standardDeviation="0.25"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_57EE71B2-5287-46A2-9B24-83A68131714C">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:ResultRequest>min</bpsim:ResultRequest>
                                <bpsim:ResultRequest>max</bpsim:ResultRequest>
                                <bpsim:ResultRequest>mean</bpsim:ResultRequest>
                                <bpsim:TruncatedNormalDistribution max="1000" mean="50" min="0" standardDeviation="10"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_D6383F72-7F7A-48F8-A742-A26F36A8DC10">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:DurationParameter value="PT1M"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_DA142784-0125-46E0-A3CA-004302BD5E21">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:DurationParameter value="PT1M"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D">
                        <bpsim:TimeParameters>
                            <bpsim:ProcessingTime>
                                <bpsim:DurationParameter value="PT1M"/>
                            </bpsim:ProcessingTime>
                        </bpsim:TimeParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_3D6F2455-BFFB-44BB-A052-892FB15FEEB4">
                        <bpsim:ControlParameters>
                            <bpsim:Probability>
                                <bpsim:FloatingParameter value="0.27"/>
                            </bpsim:Probability>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_93351D59-990B-46B0-80AB-FEEF088E9D7B">
                        <bpsim:ControlParameters>
                            <bpsim:Probability>
                                <bpsim:FloatingParameter value="0.73"/>
                            </bpsim:Probability>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_6E1A332C-9187-4C4A-BD0F-27167F940786">
                        <bpsim:ControlParameters>
                            <bpsim:TriggerCount>
                                <bpsim:ResultRequest>count</bpsim:ResultRequest>
                            </bpsim:TriggerCount>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB">
                        <bpsim:ControlParameters>
                            <bpsim:TriggerCount>
                                <bpsim:ResultRequest>count</bpsim:ResultRequest>
                            </bpsim:TriggerCount>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                    <bpsim:ElementParameters elementRef="_542AE8E6-9CEA-43E3-8177-C685A9F430FE">
                        <bpsim:ControlParameters>
                            <bpsim:InterTriggerTimer>
                                <bpsim:DurationParameter value="PT60M"/>
                            </bpsim:InterTriggerTimer>
                        </bpsim:ControlParameters>
                    </bpsim:ElementParameters>
                </bpsim:Scenario>
            </bpsim:BPSimData>
        </bpmn:extensionElements>
        <bpmn:source>_1364754643385</bpmn:source>
        <bpmn:target>_1364754643385</bpmn:target>
    </bpmn:relationship>
</bpmn:definitions>'! !

!BPSimParserTest methodsFor: 'tests' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:09'!
testExample2HasOneScenario
	| bpsimdata |
	bpsimdata := BPSimParser parseString: BPSimParserTest example2.
	self assert: bpsimdata scenarios size = 1! !

!BPSimParserTest methodsFor: 'tests' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:42'!
testExample2Scenario1ReplicateThreeTimes
	| bpsimdata scenario scenarioParameters duration|
	bpsimdata := BPSimParser parseString: BPSimParserTest example2.
	
	scenario := bpsimdata scenarios first.
	
	"<bpsim:Scenario author=""Tim Stephenson"" id=""default"" name=""Scenario 1"">"
	self assert: scenario author = 'Tim Stephenson'.
	self assert: scenario id = 'default'.
	self assert: scenario name = 'Scenario 1'.			
	"
	<bpsim:ScenarioParameters baseTimeUnit=""min"" replication=""3"">
		<bpsim:Duration>
			<bpsim:DurationParameter value=""PT40H""/>
		</bpsim:Duration>
	</bpsim:ScenarioParameters>
	"
	scenarioParameters := scenario scenarioParameters.
	self assert: scenarioParameters replication = 3.
	self assert: scenario scenarioParameters baseTimeUnit = 'min'.
	
	duration := scenarioParameters duration.
	self assert: duration class = BPSimDurationParameter.
	self assert: duration value = 'PT40H'.
		! !

TestCase subclass: #BPSimScenarioTest
	instanceVariableNames: 'example1 example2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-Tests'!

!BPSimScenarioTest commentStamp: '<historical>' prior: 0!
A BPSimScenarioTest is a test class for testing the behavior of BPSimScenario!

!BPSimScenarioTest methodsFor: 'running' stamp: 'SergeStinckwich 3/6/2015 14:50'!
setUp
	"Example taken from BPSim Implementer's guide: Example 1: Repairing a motor vehicle"

	self setUpExample1.
	self setUpExample2! !

!BPSimScenarioTest methodsFor: 'running' stamp: 'SergeStinckwich 3/6/2015 17:15'!
setUpElementParametersExample2Scenario1
	| elementParameters  |
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_6'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_4E504F9B-2618-424F-ABAA-C4D4CC2D75E0'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_BAE2D4BB-902F-4C3C-AF76-A0CABBA9A7AE'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_2017EC19-4BD5-40D7-9014-E7D337A68E01'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_0CA1F609-5DFA-43E2-96DE-6CBD97BFAC5A'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_4A0E10F8-6AC7-4AF0-AFD3-5E0CB00BD316'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_ACDC390F-49FD-43A3-ACD6-1EBB8074801D'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_C94EFA57-E605-4564-BFC4-22A84C660A6A'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_65F6E8B9-FDD3-4770-B12B-87862F37BDF6'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_F366069F-C180-4D69-B2BF-4124649EC36F'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_57EE71B2-5287-46A2-9B24-83A68131714C'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_D6383F72-7F7A-48F8-A742-A26F36A8DC10'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_DA142784-0125-46E0-A3CA-004302BD5E21'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_3330ACC4-BCD9-422A-ADCD-7DDF06A2042D'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_3D6F2455-BFFB-44BB-A052-892FB15FEEB4'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_93351D59-990B-46B0-80AB-FEEF088E9D7B'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_6E1A332C-9187-4C4A-BD0F-27167F940786'.
	example2 scenarios first addElementParameters: elementParameters.
	
	elementParameters := BPSimElementParameters new.
	elementParameters elementRef: '_A2A06973-DC30-4BCF-BF0F-1FD60D68E1EB'.
	example2 scenarios first addElementParameters: elementParameters.
	! !

!BPSimScenarioTest methodsFor: 'running' stamp: 'SergeStinckwich 3/6/2015 15:49'!
setUpExample1
	"Example taken from BPSim Implementer's guide: Example 1: Repairing a motor vehicle"

	| scenarioParameters scenario1|
	example1 := BPSimData new.
	scenario1 := BPSimScenario new.
	scenario1
		id: #S1;
		author: 'Tim Stephenson';
		name: 'Scenario 1: Main flow without sub-processes'.
	scenario1
		created: '2013-03-06T21:00:00';
		modified: '2013-03-06T21:00:00'.
	scenarioParameters := BPSimScenarioParameters new.
	scenarioParameters replication: 3.
	scenario1 scenarioParameters: scenarioParameters.
	scenario1 scenarioParameters duration: 60 minutes.
	
	example1 addScenario: scenario1.! !

!BPSimScenarioTest methodsFor: 'running' stamp: 'SergeStinckwich 3/6/2015 17:11'!
setUpExample2
	"Example taken from BPSim Implementer's guide: Example 2: Originating a home loan"

	| scenarioParameters scenario1 |
	example2 := BPSimData new.
	
	scenario1 := BPSimScenario new.
	scenario1
		id: #default;
		author: 'Tim Stephenson';
		name: 'Scenario 1'.
	scenarioParameters := BPSimScenarioParameters new.
	scenarioParameters replication: 2.
	scenario1 scenarioParameters: scenarioParameters.
	scenario1 scenarioParameters duration: 40 minutes.
	example2 addScenario: scenario1.
	self setUpElementParametersExample2Scenario1! !

!BPSimScenarioTest methodsFor: 'tests' stamp: 'SergeStinckwich 3/6/2015 15:53'!
testEighteenElementParametersInExample2Scenario1
	self assert: example2 scenarios first elementParameters size == 18! !

!BPSimScenarioTest methodsFor: 'tests' stamp: 'SergeStinckwich 3/6/2015 15:51'!
testExample1Scenario1Parameters
	self assert: example1 scenarios first scenarioParameters replication = 3.
	self assert: example1 scenarios first scenarioParameters duration = 60 minutes! !

!BPSimScenarioTest methodsFor: 'tests' stamp: 'SergeStinckwich 3/6/2015 16:04'!
testExample2Scenario1Parameters
	self assert: example2 scenarios first scenarioParameters replication = 2.
	self assert: example2 scenarios first scenarioParameters duration = 40 minutes! !

!BPSimScenarioTest methodsFor: 'tests' stamp: 'SergeStinckwich 3/6/2015 16:49'!
testSetupExample1Scenario1
	self assert: example1 scenarios first author = 'Tim Stephenson'! !

Object subclass: #BPSimAbstractVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-visitors'!

!BPSimAbstractVisitor methodsFor: 'visitor-Basic' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:56'!
visitA4BPUnParserObj: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:35'!
visitBPDuration: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:56'!
visitBPSimBetaDistribution: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimBinomialDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimBooleanParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimCalendar:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimConstantParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimControlParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimCostParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimData:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimDateTimeParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimDistributionParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimDurationParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimElementParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimEnumParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimErlangDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimExpressionParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimFloatingParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimGammaDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimLogNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimNegativeExponentialDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimNumericParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor-Basic' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimObject: aModel
	"do nothing"
	^ nil! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimObjectFactory:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimParameterValue:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimPoissonDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimPriorityParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimProperty:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimPropertyParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimResourceParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimScenario:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimScenarioParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimStringParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimTimeParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimTriangularDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimTruncatedNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimUniformDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimUserDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimUserDistributionDataPoint:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimVendorExtension:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:39'!
visitBPSimWeibullDistribution:aModel 
	^ self visitBPSimObject: aModel! !

BPSimAbstractVisitor subclass: #BPSimExecutionVisitor
	instanceVariableNames: 'inputScenario outputScenario inElementParameter outElementParameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-execution'!

!BPSimExecutionVisitor methodsFor: 'simulation' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:02'!
run: process
	process accept: self! !

BPSimAbstractVisitor subclass: #BPSimParserAbstractVisitor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser-builder-visitors'!

!BPSimParserAbstractVisitor methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:48'!
addElement: aModel
	element addChildren: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:49'!
addmyRoot: aModel
	"add definitions as a root implements"
	| root |
	root := element myRoot.
	root addElementInDictionary: aModel .
	aModel myRoot: root.! !

!BPSimParserAbstractVisitor methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:48'!
element: aElement
	element := aElement! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:35'!
visitBPDuration: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:35'!
visitBPSimBetaDistribution: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimBinomialDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimBooleanParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimCalendar:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimConstantParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimControlParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimCostParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimData:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimDateTimeParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimDistributionParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:38'!
visitBPSimDurationParameter: aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimElementParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimEnumParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimErlangDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimExpressionParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimFloatingParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimGammaDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimLogNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimNegativeExponentialDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimNumericParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor-Basic' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:38'!
visitBPSimObject: aModel
	"do nothing"
	^ nil! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimObjectFactory:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimParameterValue:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimPoissonDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimPriorityParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimProperty:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimPropertyParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimResourceParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimScenario:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimScenarioParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimStringParameter:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimTimeParameters:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimTriangularDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimTruncatedNormalDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimUniformDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimUserDistribution:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimUserDistributionDataPoint:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimVendorExtension:aModel 
	^ self visitBPSimObject: aModel! !

!BPSimParserAbstractVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:35'!
visitBPSimWeibullDistribution:aModel 
	^ self visitBPSimObject: aModel! !

BPSimParserAbstractVisitor subclass: #BPSimParserDataVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser-builder-visitors'!

!BPSimParserDataVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:55'!
visitBPSimScenario: aModel 
	element addScenario: aModel! !

BPSimParserAbstractVisitor subclass: #BPSimParserDurationVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser-builder-visitors'!

!BPSimParserDurationVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:41'!
visitBPSimDurationParameter: aModel
	element constantParameter: aModel! !

BPSimParserAbstractVisitor subclass: #BPSimParserScenarioParametersVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser-builder-visitors'!

!BPSimParserScenarioParametersVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 12:42'!
visitBPDuration: aModel 
	element duration: aModel constantParameter.! !

BPSimParserAbstractVisitor subclass: #BPSimParserScenarioVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-parser-builder-visitors'!

!BPSimParserScenarioVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 11:51'!
visitBPSimScenarioParameters: aModel 
	element scenarioParameters: aModel.
! !

Object subclass: #BPSimEngineController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-execution'!

Object subclass: #BPSimEngineProcess
	instanceVariableNames: 'process executions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-core-execution'!

!BPSimEngineProcess methodsFor: 'simulation' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 17:58'!
addExecution: execution
	executions add: execution! !

!BPSimEngineProcess methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 17:59'!
initialize
	super initialize.
	executions := OrderedCollection new.! !

!BPSimEngineProcess methodsFor: 'simulation' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 18:01'!
runNewExecution
	| execution |
	execution := self starNewExecution.
	self addExecution: execution.
	execution run: process! !

!BPSimEngineProcess methodsFor: 'simulation' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 15:23'!
starNewExecution
	^ BPSimExecutionVisitor new
	! !
